// name   : ClassC.cs
// author : Harald Maier
// date   : 23.01.2004
//
//
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version.                                   

using System;
using System.Drawing;
using System.Drawing.Drawing2D;

using SoaringDotNET.Data;

namespace SoaringDotNET.GUI
{
	/// <summary>
	/// 
	/// </summary>
	public class ClassC : SoaringDotNET.GUI.AirspaceElement
	{
        public ClassC(Airspace space) :
        base(space) {
			// 
			// TODO: Add constructor logic here
			//
            if (space.airspaceType == AirspaceTypes.ControlZone) {
                pen.Color = AppContents.classCCTRColor.DrawColor;
                pen.Width = AppContents.classCCTRColor.Width;
                brush = new HatchBrush(HatchStyle.DottedGrid, pen.Color, Color.Transparent);
            }
            else if (space.airspaceType == AirspaceTypes.TerminalControlArea) {
                pen.Color = AppContents.classCColor.DrawColor;
                pen.Width = AppContents.classCColor.Width;
                brush = Brushes.Transparent;
            }
            else {
                pen.Color = AppContents.classCColor.DrawColor;
                pen.Width = AppContents.classCColor.Width;
                brush = new SolidBrush(Color.FromArgb(30, pen.Color));
            }
        }
	}
}
